<template>
  <div class="shop">
    <v-notification
      :messages="messages"
      :timeout="3000"
    />
    <div class="shop-wrap grid grid-cols-2 text-sm auto-cols-auto divide-none sm:divide-x divide-dashed">
      <div class="p-4 lg:pt-4 pt-0 divide-none sm:divide-y divide-dashed shop-navigate-wrap">
        <router-link :to="{name: 'Shop', params: {category: index}}"
            v-for="(category,index) in categories"
            :key="category.name"
            @click="selectActiveCategory(index)"
            class="category py-1 pointer block"
            :class="{'active-category':selectedCategory === index}"
        >
          {{category.name}}
        </router-link>
      </div>
      <select class="mx-auto sm:hidden p-3 mobile-selected-category select-sort-mobile" @change="selectActiveCategory(selectedCategory)" v-model="selectedCategory" style="-o-appearance: none;">
        <option v-for="(name,index) in categories" :key="'option-'+name" :value="index">{{name}}</option>
      </select>
      <div class="products-wrap grid-rows-2">
        <div class="filters-wrap">
          <div @click="searchModal = true">
            <img src="../assets/images/icons/magnify.png" alt="">
          </div>
          <router-link :to="{name: 'Basket'}">
            <img src="../assets/images/icons/cart-outline.png" alt="">
          </router-link>
        </div>
        <div v-if="loadingGetProducts" class="lazy-loading">
          <LoadsSpinner class="wait" v-if="loadingGetProducts" large/>
        </div>
        <div :class="loadingGetProducts&&'pointerEventsNone'" class="grid grid-cols-1 sm:grid-cols-3 lg:grid-cols-5 px-2 pb-4 py-0 bg-white">
          <router-link
              :to="{
                name: 'Product',
                params: {
                  category: selectedCategory,
                  product: index,
                  id: product.product_id
                }
              }"
              v-for="(product,index) in products"
              :key="'product-' + index"
          >
            <div v-if="index <= quantityOfVisibleProducts" class="
              flex column hover:border-gray-200 p-2 m-2 pointer product
            ">
              <ProductImage
                  :image="(product.image.indexOf('https') >= 0 && product.image) || 'https://s3333.ru/' + product.image"
              />
              <div v-if="product.price !== '0.0000'" class="flex items-center product-by-wrap">
                <div @click.prevent="productBy(product)" class="h-1/3 product-by">Заказать</div>
                <div class="text-right my-3 ml-auto">
                  <span class="text-xl sm:text-lg color-red mr-1">{{Math.floor(product.price * 100) / 100}}</span>₽
                </div>
              </div>
              <div :title="product.name" class="text-center sm:text-left mb-4 sm:mb-0"><span class="text-xs sm:text-sm clip">{{product.name}}</span></div>
            </div>
          </router-link>
        </div>
        <div
            v-if="quantityOfVisibleProducts < products.length + 1"
            class="button w-1/2 sm:w-1/3 mx-auto my-4 mb-20 sm:mb-0"
            @click="showMore"
        >
          Показать еще
        </div>
      </div>
    </div>
    <Modal v-if="searchModal" @close="searchModal = false">
      <template v-slot:body>
        <div>
          <div v-if="!searchData.length" class="text-xl text-white mb-2 opacity-75">Поиск по продуктам</div>
          <div v-if="searchData.length" class="text-right text-xs text-white mb-2 opacity-50">Найдено {{ searchData.length }} продуктов</div>
          <input
            v-model="queryText"
            type="text"
            placeholder="Что ищем?"
            class="text-white"
          >
        </div>
        <div v-if="searchData.length && !finishedSearch" class="search-wrap pt-4">
          <router-link
            :to="{
                name: 'Product',
                params: {
                  category: product.categoryIndex,
                  product: product.productIndex,
                  id: product.product_id
                }
              }"
            v-for="(product, i) in searchData"
            :key="`search-products-${product.product_id + Math.floor(Math.random() * (9999 - 1 + 1))}`"
            class="text-white grid grid-cols-3 px-10 my-2 pointer"
          >
            <div style="max-width: 60px"><img :src="(product.image.indexOf('https') >= 0 && product.image) || 'https://s3333.ru/' + product.image" alt=""></div>
            <div class="clip" :title="product.name">{{product.name}}</div>
            <div v-if="product.price !== '0.0000'">{{Math.floor(product.price * 100) / 100}} ₽</div>
          </router-link>
        </div>
      </template>
    </Modal>
  </div>
</template>

<script>
// выборка и т.п. в firebase
// https://www.youtube.com/watch?v=sKFLI5FOOHs

import {ref, onMounted, watch} from 'vue'
import { useRoute } from 'vue-router'
import {getDatabase, onValue, ref as fireRef} from "firebase/database";
import LoadsSpinner from "../components/Loads-spinner.vue";
import ProductImage from "../components/productImage.vue";
import firebase from "firebase/compat";
import Modal from "../components/Modal.vue";
import VNotification from "../components/Notice.vue";
import {useStore} from "vuex";

export default {
  name: "Shop",
  components: {VNotification, Modal, ProductImage, LoadsSpinner},
  setup() {
    const route = useRoute()
    const store = useStore()
    const rootRef = firebase.database().ref('/shop/')
    const categories = ref([
      {name: "Носители информации"},
      {name: "Свет и хозгруппа"},
      {name: "Компьютерная периферия"},
      {name: "Аксессуары для фото и видео техники"},
      {name: "Сублимация и Полиграфия"},
      {name: "Папки для выпускников"},
      {name: "Расходные материалы для фотопечати"},
      {name: "Элементы питания"},
      {name: "Рамки"},
      {name: "Фотоальбомы с кармашками"},
      {name: "Фотоальбомы Свадебные"},
      {name: "Фотоальбом с магнитными листами"},
      {name: "Канцелярские товары и сувениры"},
      {name: "Акции"},
      {name: "Новинки"}
    ])

    // search
    const searchData = ref([])
    const searchArray = ref([])
    const searchModal = ref(false)
    const finishedSearch = ref(false)

    // Notice
    const messages = ref([])

    // индекс выбранной категории
    const selectedCategory = ref(Number(route.params.category))
    const products = ref([])
    // текущее количество показываемых продуктов
    const quantityOfVisibleProducts = ref(10)
    const loadingGetProducts = ref(false)
    const loadingGetImageProducts = ref(true)
    const queryText = ref('')

    // показать еще 10 продуктов
    function showMore () {
      quantityOfVisibleProducts.value += 15
      getProductsSelectedCategory()
    }

    // выбор новой категории
    async function selectActiveCategory(index) {
      loadingGetProducts.value = true
      // индекс выбранной категории
      selectedCategory.value = index
      quantityOfVisibleProducts.value = 10
      //обнулить чтобы накидать в массив продукты выбранной категории
      products.value.splice(0, products.value.length)
      // закидываем новые продукты
      setTimeout(async ()=> {
        await getProductsSelectedCategory(index)
      }, 50)
    }

    // запрос названий категорий, без их продуктов
    async function getCategoriesDB (index = 0) {
      const db = await getDatabase();
      rootRef.orderByKey().on("child_added", async function(snapshot) {
        // получаем имена категорий по их индексу без их продуктов
        const starCountRef = await fireRef(db, '/shop/' + snapshot.key + '/name');
        await onValue(starCountRef, (snapshot) => {
          categories.value.push(snapshot.val())
        });
      });
      await getProductsSelectedCategory()
    }

    // запросить quantityOfVisibleProducts продуктов текущей категории
    // текущая категория это - selectedCategory (индекс)
    // функцию можно упростить с помощью limitToFirst(quantityOfVisibleProducts.value + 5)
    async function getProductsSelectedCategory (index) {
      loadingGetProducts.value = true
      const db = await getDatabase();
      rootRef.child(String(selectedCategory.value)).child('products').limitToFirst(quantityOfVisibleProducts.value).once("value")
          .then(function(snapshot) {
            products.value = snapshot.val()
            loadingGetProducts.value = false
          });
    }

    function debounce(func, wait, immediate) {
      let timeout;

      return function executedFunction() {
        const context = this;
        const args = arguments;

        const later = function() {
          timeout = null;
          if (!immediate) func.apply(context, args);
        };

        const callNow = immediate && !timeout;

        clearTimeout(timeout);

        timeout = setTimeout(later, wait);

        if (callNow) func.apply(context, args);
      };
    }
    async function searchFunction() {
      finishedSearch.value = true
      let str = queryText.value.toLowerCase()
      let flag = true
      function pereborArray () {
        searchArray.value.forEach((category, i)=>{
          searchData.value.push( ...category.products.filter((productItem, index)=>{
            if (~productItem.name.toLowerCase().indexOf(str)||~productItem.model.toLowerCase().indexOf(str)) {
              productItem.category = category.name
              productItem.categoryIndex = i
              productItem.productIndex = index
              finishedSearch.value = false
              flag = false
              return productItem
            }
          }))
        })
      }
      if (
          Number(queryText.value) && queryText.value.length>5 || !Number(queryText.value) && queryText.value.length>=4
      ) {
        if (flag) {
          // не делать запрос всего /shop
          if (searchArray.value.length && flag) {
            searchData.value.splice(0, searchData.value.length)
            pereborArray()
            return searchData.value;
          } else {
            searchData.value.splice(0, searchData.value.length)
            await rootRef.once("value")
                .then(function(snapshot) {
                  searchArray.value = snapshot.val()
                });
            pereborArray()
            return searchData.value;
          }
        }
      }
    }

    // Добавление в Корзину
    function productBy(product) {
      store.commit('addCartItem', product)
      const timeStamp = Date.now().toLocaleString()
      messages.value.unshift(
        { name: 'Добавлено в корзину', icon: 'check_circle', id: timeStamp }
      )
    }

    watch(queryText, debounce(searchFunction, 300))

    onMounted(async ()=>{
      await getProductsSelectedCategory()
    })

    return {
      categories,
      products,
      selectedCategory,
      quantityOfVisibleProducts,
      loadingGetProducts,
      loadingGetImageProducts,
      queryText,
      searchData,
      searchModal,
      finishedSearch,
      messages,
      selectActiveCategory,
      showMore,
      productBy,
    }
  }
}
</script>

<style scoped lang="scss">
.shop {
  @media (max-width: 850px) {
    padding: 0;
  }
  .shop-wrap {
    grid-template-columns: 1fr 3fr;
    overflow-y: hidden;
    max-height: calc(100vh - 116px);
    min-height: calc(100vh - 116px);
    min-width: 100vw;
    .mobile-selected-category {
      background-color: #232323;
      color: white;
      width: 100%;
      text-align: center;
    }
    @media (max-width: 850px) {
      grid-template-columns: 1fr;
    }
    .shop-navigate-wrap {
      max-height: calc(100vh - 116px);
      overflow-y: auto;
      box-shadow: 1px 0 5px rgba(0,0,0, 0.1);
      z-index: 2;
      @media (max-width: 850px) {
        display: none;
        position: fixed;
        width: 100vw;
        height: 100vh;
      }
      .category {
        border-radius: 3px;
        cursor: pointer;
        color: #000000;
        padding-left: 10px;
        &.active-category {
          background-color: #d52828;
          color: white;
          &:hover {
            color: white;
          }
        }
        &:hover {
          color: #d52828;
        }
      }
    }
    .products-wrap {
      overflow-y: auto;
      overflow-x: hidden;
      max-height: calc(100vh - 116px);
      position: relative;
      .product {
        box-shadow: 0 2px 4px rgba(0, 0, 0, 0.07);
        &:hover {
          box-shadow: 0 2px 4px rgba(0, 0, 0, 0.22);
          .product-by-wrap .product-by {
            display: block;
          }
        }
        .product-by-wrap {
          .product-by {
            display: none;
            font-weight: bold;
            margin-left: 10px;
            opacity: .8;
            padding: 4px 10px;
            &:hover {
              box-shadow: 0 2px 4px rgba(0, 0, 0, 0.07);
              background-color: rgba(225, 218, 218, 0.4);
            }
          }
        }
        .ProductImage {
          max-width: 100%;
          img{
            max-width: 100%;
          }
        }
      }
    }
    .filters-wrap {
      position: fixed;
      top: 120px;
      right: 30px;
      height: 200px;
      z-index: 3;
      @media (max-width: 850px) {
        top: 90px;
      }
      @media (max-width: 450px) {
        right: 0;
      }
      &:hover{
        border-radius: 5px;
        div, a {
          border-radius: 5px;
        }
        @media (max-width: 850px) {
          border-radius: 50%;
        }
        :first-child:before {
          content: 'Поиск';
          color: white;
          margin-right: 7px;
          margin-left: 5px;
          @media (max-width: 850px) {
            display: none;
          }
        }
        :last-child:before {
          content: 'Корзина';
          color: white;
          margin-right: 7px;
          margin-left: 5px;
          @media (max-width: 850px) {
            display: none;
          }
        }
      }
      div, a {
        background: black;
        @media (max-width: 850px) {
          background: none;
        }
        padding: 5px;
        display: flex;
        justify-content: center;
        align-items: center;
        margin-bottom: 5px;
        border-radius: 50%;
        cursor: pointer;
        position: relative;
      }
      input {
        color: white;
      }
    }
  }
}

.pointerEventsNone {
  pointer-events: none;
}
.lazy-loading {
  position: absolute;
  width: 100%;
  max-width: 100%;
  height: 100%;
  background-color: rgba(255, 255, 255, 0.3);
  backdrop-filter: blur(3px);
  max-height: calc(100vh - 116px);
  display: flex;
  justify-content: center;
  align-items: center;
  z-index: 100;
  overflow: hidden;
  .wait {
    width: 35px;
    height: 35px;
  }
}
.search-wrap {
  max-height: 200px;
  overflow-y: auto;
}
.clip {
  overflow: hidden;
  text-overflow: ellipsis;
  display: -webkit-box;
  -webkit-line-clamp: 2;
  -webkit-box-orient: vertical;
}
.select-sort-mobile {
  /* for Firefox */
  -moz-appearance: none;
  /* for Chrome */
  -webkit-appearance: none;
}
.select-sort-mobile::-ms-expand {
  /* IE */
  display: none;
}
</style>
